from base64 import b64encode
from datetime import datetime

from clowm.core.config import settings
from clowm.schemas.tower import BeginWorkflow, CompleteWorkflow, ReportProgress

_digest = b64encode(f"@token:{settings.cluster.tower_secret.get_secret_value()}".encode()).decode("utf-8")
security_header = {"Authorization": f"Basic {_digest}"}

begin_workflow_event = BeginWorkflow.model_validate(
    {
        "instant": datetime.now().timestamp(),
        "workflow": {
            "start": "2023-02-28T08:41:08.402Z",
            "projectDir": "string",
            "manifest": {
                "doi": "string",
                "nextflowVersion": "string",
                "defaultBranch": "string",
                "version": "string",
                "homePage": "https://example.com",
                "gitmodules": "string",
                "description": "string",
                "recurseSubmodules": False,
                "name": "string",
                "mainScript": "string",
                "author": "string",
            },
            "complete": "2023-02-28T08:41:08.402Z",
            "profile": "string",
            "homeDir": "string",
            "workDir": "string",
            "container": "string",
            "commitId": "string",
            "errorMessage": "string",
            "repository": "https://example.com",
            "containerEngine": "string",
            "scriptFile": "string",
            "userName": "string",
            "launchDir": "string",
            "runName": "string",
            "configFiles": ["string"],
            "sessionId": "string",
            "errorReport": "string",
            "workflowStats": {
                "succeededCount": 0,
                "computeTimeFmt": "string",
                "cachedCount": 0,
                "processes": [
                    {
                        "index": 0,
                        "pending": 0,
                        "ignored": 0,
                        "loadCpus": 0,
                        "succeeded": 0,
                        "running": 0,
                        "retries": 0,
                        "peakRunning": 0,
                        "name": "string",
                        "loadMemory": 0,
                        "stored": 0,
                        "terminated": False,
                        "aborted": 0,
                        "failed": 0,
                        "peakCpus": 0,
                        "peakMemory": 0,
                        "cached": 0,
                        "submitted": 0,
                    }
                ],
                "changeTimestamp": 0,
                "peakRunning": 0,
                "succeedDuration": 0,
                "cachedPct": 0,
                "loadMemory": 0,
                "succeedCountFmt": "string",
                "failedPct": 0,
                "ignoredCount": 0,
                "submittedCount": 0,
                "peakMemory": 0,
                "succeedPct": 0,
                "succeedCount": 0,
                "runningCount": 0,
                "pendingCount": 0,
                "loadCpus": 0,
                "cachedDuration": 0,
                "abortedCount": 0,
                "failedDuration": 0,
                "failedCount": 0,
                "loadMemoryFmt": "string",
                "retriesCount": 0,
                "cachedCountFmt": "string",
                "progressLength": 0,
                "peakMemoryFmt": "string",
                "failedCountFmt": "string",
                "ignoredCountFmt": "string",
                "peakCpus": 0,
                "ignoredPct": 0,
            },
            "scriptId": "string",
            "revision": "string",
            "exitStatus": 0,
            "commandLine": "string",
            "stubRun": False,
            "nextflow": {
                "version": "string",
                "build": 0,
                "timestamp": "2023-02-28T08:41:08.402Z",
                "enable": {"additionalProp1": 0, "additionalProp2": 0, "additionalProp3": 0},
            },
            "stats": {
                "succeededCount": 0,
                "computeTimeFmt": "string",
                "cachedCount": 0,
                "processes": [
                    {
                        "index": 0,
                        "pending": 0,
                        "ignored": 0,
                        "loadCpus": 0,
                        "succeeded": 0,
                        "running": 0,
                        "retries": 0,
                        "peakRunning": 0,
                        "name": "string",
                        "loadMemory": 0,
                        "stored": 0,
                        "terminated": False,
                        "aborted": 0,
                        "failed": 0,
                        "peakCpus": 0,
                        "peakMemory": 0,
                        "cached": 0,
                        "submitted": 0,
                    }
                ],
                "changeTimestamp": 0,
                "peakRunning": 0,
                "succeedDuration": 0,
                "cachedPct": 0,
                "loadMemory": 0,
                "succeedCountFmt": "string",
                "failedPct": 0,
                "ignoredCount": 0,
                "submittedCount": 0,
                "peakMemory": 0,
                "succeedPct": 0,
                "succeedCount": 0,
                "runningCount": 0,
                "pendingCount": 0,
                "loadCpus": 0,
                "cachedDuration": 0,
                "abortedCount": 0,
                "failedDuration": 0,
                "failedCount": 0,
                "loadMemoryFmt": "string",
                "retriesCount": 0,
                "cachedCountFmt": "string",
                "progressLength": 0,
                "peakMemoryFmt": "string",
                "failedCountFmt": "string",
                "ignoredCountFmt": "string",
                "peakCpus": 0,
                "ignoredPct": 0,
            },
            "resume": False,
            "success": False,
            "projectName": "string",
            "scriptName": "string",
            "duration": 0,
            "params": {
                "additionalProp1": "string",
            },
            "id": "string",
            "configText": "string",
            "operationId": "string",
            "logFile": "string",
            "outFile": "string",
        },
        "processNames": ["string"],
        "towerLaunch": False,
    }
)

progress_event = ReportProgress.model_validate(
    {
        "instant": datetime.now().timestamp(),
        "tasks": [
            {
                "taskId": 0,
                "status": "COMPLETED",
                "hash": "string",
                "name": "string",
                "exit": 0,
                "submit": "2023-02-28T08:46:32.691Z",
                "start": "2023-02-28T08:46:32.691Z",
                "process": "string",
                "tag": "string",
                "module": ["string"],
                "container": "string",
                "attempt": 0,
                "script": "string",
                "scratch": "string",
                "workdir": "string",
                "queue": "string",
                "cpus": 3,
                "memory": 0,
                "disk": "string",
                "time": 0,
                "errorAction": "string",
                "complete": "2023-02-28T08:46:32.691Z",
                "env": "string",
                "duration": 0,
                "realtime": 600000,
                "pcpu": 0,
                "rchar": 0,
                "wchar": 0,
                "syscr": 0,
                "syscw": 0,
                "readBytes": 0,
                "writeBytes": 0,
                "pmem": 0,
                "vmem": 0,
                "rss": 0,
                "peakVmem": 0,
                "peakRss": 0,
                "volCtxt": 0,
                "invCtxt": 0,
                "nativeId": 0,
                "executor": "string",
                "cloudZone": "string",
                "machineType": "string",
                "priceModel": "string",
            }
        ],
        "progress": {
            "pending": 0,
            "ignored": 0,
            "loadCpus": 0,
            "loadMemory": 0,
            "processes": [
                {
                    "index": 0,
                    "pending": 0,
                    "ignored": 0,
                    "loadCpus": 0,
                    "succeeded": 0,
                    "running": 0,
                    "retries": 0,
                    "peakRunning": 0,
                    "name": "string",
                    "loadMemory": 0,
                    "stored": 0,
                    "terminated": False,
                    "aborted": 0,
                    "failed": 0,
                    "peakCpus": 0,
                    "peakMemory": 0,
                    "cached": 0,
                    "submitted": 0,
                }
            ],
            "aborted": 0,
            "succeeded": 0,
            "peakMemory": 0,
            "peakCpus": 0,
            "failed": 0,
            "running": 0,
            "retries": 0,
            "peakRunning": 0,
            "cached": 0,
            "submitted": 0,
        },
    }
)

complete_workflow_event = CompleteWorkflow.model_validate(
    {
        "instant": datetime.now().timestamp(),
        "workflow": {
            "start": "2023-02-28T08:47:12.191Z",
            "projectDir": "string",
            "manifest": {
                "doi": "string",
                "nextflowVersion": "string",
                "defaultBranch": "string",
                "version": "string",
                "homePage": "https://example.com",
                "gitmodules": "string",
                "description": "string",
                "recurseSubmodules": False,
                "name": "string",
                "mainScript": "string",
                "author": "string",
            },
            "complete": "2023-02-28T08:47:12.191Z",
            "profile": "string",
            "homeDir": "string",
            "workDir": "string",
            "container": "string",
            "commitId": "string",
            "errorMessage": "string",
            "repository": "https://example.com",
            "containerEngine": "string",
            "scriptFile": "string",
            "userName": "string",
            "launchDir": "string",
            "runName": "string",
            "configFiles": ["string"],
            "sessionId": "string",
            "errorReport": "string",
            "workflowStats": {
                "succeededCount": 0,
                "computeTimeFmt": "string",
                "cachedCount": 0,
                "processes": [
                    {
                        "index": 0,
                        "pending": 0,
                        "ignored": 0,
                        "loadCpus": 0,
                        "succeeded": 0,
                        "running": 0,
                        "retries": 0,
                        "peakRunning": 0,
                        "name": "string",
                        "loadMemory": 0,
                        "stored": 0,
                        "terminated": False,
                        "aborted": 0,
                        "failed": 0,
                        "peakCpus": 0,
                        "peakMemory": 0,
                        "cached": 0,
                        "submitted": 0,
                    }
                ],
                "changeTimestamp": 0,
                "peakRunning": 0,
                "succeedDuration": 0,
                "cachedPct": 0,
                "loadMemory": 0,
                "succeedCountFmt": "string",
                "failedPct": 0,
                "ignoredCount": 0,
                "submittedCount": 0,
                "peakMemory": 0,
                "succeedPct": 0,
                "succeedCount": 0,
                "runningCount": 0,
                "pendingCount": 0,
                "loadCpus": 0,
                "cachedDuration": 0,
                "abortedCount": 0,
                "failedDuration": 0,
                "failedCount": 0,
                "loadMemoryFmt": "string",
                "retriesCount": 0,
                "cachedCountFmt": "string",
                "progressLength": 0,
                "peakMemoryFmt": "string",
                "failedCountFmt": "string",
                "ignoredCountFmt": "string",
                "peakCpus": 0,
                "ignoredPct": 0,
            },
            "scriptId": "string",
            "revision": "string",
            "exitStatus": 0,
            "commandLine": "string",
            "stubRun": False,
            "nextflow": {
                "version": "string",
                "build": 0,
                "timestamp": "2023-02-28T08:47:12.192Z",
                "enable": {"additionalProp1": 0, "additionalProp2": 0, "additionalProp3": 0},
            },
            "stats": {
                "succeededCount": 0,
                "computeTimeFmt": "string",
                "cachedCount": 0,
                "processes": [
                    {
                        "index": 0,
                        "pending": 0,
                        "ignored": 0,
                        "loadCpus": 0,
                        "succeeded": 0,
                        "running": 0,
                        "retries": 0,
                        "peakRunning": 0,
                        "name": "string",
                        "loadMemory": 0,
                        "stored": 0,
                        "terminated": False,
                        "aborted": 0,
                        "failed": 0,
                        "peakCpus": 0,
                        "peakMemory": 0,
                        "cached": 0,
                        "submitted": 0,
                    }
                ],
                "changeTimestamp": 0,
                "peakRunning": 0,
                "succeedDuration": 0,
                "cachedPct": 0,
                "loadMemory": 0,
                "succeedCountFmt": "string",
                "failedPct": 0,
                "ignoredCount": 0,
                "submittedCount": 0,
                "peakMemory": 0,
                "succeedPct": 0,
                "succeedCount": 0,
                "runningCount": 0,
                "pendingCount": 0,
                "loadCpus": 0,
                "cachedDuration": 0,
                "abortedCount": 0,
                "failedDuration": 0,
                "failedCount": 0,
                "loadMemoryFmt": "string",
                "retriesCount": 0,
                "cachedCountFmt": "string",
                "progressLength": 0,
                "peakMemoryFmt": "string",
                "failedCountFmt": "string",
                "ignoredCountFmt": "string",
                "peakCpus": 0,
                "ignoredPct": 0,
            },
            "resume": False,
            "success": True,
            "projectName": "string",
            "scriptName": "string",
            "duration": 0,
            "params": {"additionalProp1": "string", "additionalProp2": "string", "additionalProp3": "string"},
            "id": "string",
            "configText": "string",
            "operationId": "string",
            "logFile": "string",
            "outFile": "string",
        },
        "metrics": [
            {
                "cpuUsage": {
                    "mean": 0,
                    "min": 0,
                    "q1": 0,
                    "q2": 0,
                    "q3": 0,
                    "max": 0,
                    "minLabel": "string",
                    "maxLabel": "string",
                    "q1Label": "string",
                    "q2Label": "string",
                    "q3Label": "string",
                },
                "process": "string",
                "mem": None,
                "memUsage": None,
                "timeUsage": None,
                "vmem": {
                    "mean": 0,
                    "min": 0,
                    "q1": 0,
                    "q2": 0,
                    "q3": 0,
                    "max": 0,
                    "minLabel": "string",
                    "maxLabel": "string",
                    "q1Label": "string",
                    "q2Label": "string",
                    "q3Label": "string",
                },
                "reads": {
                    "mean": 0,
                    "min": 0,
                    "q1": 0,
                    "q2": 0,
                    "q3": 0,
                    "max": 0,
                    "minLabel": "string",
                    "maxLabel": "string",
                    "q1Label": "string",
                    "q2Label": "string",
                    "q3Label": "string",
                },
                "cpu": {
                    "mean": 0,
                    "min": 0,
                    "q1": 0,
                    "q2": 0,
                    "q3": 0,
                    "max": 0,
                    "minLabel": "string",
                    "maxLabel": "string",
                    "q1Label": "string",
                    "q2Label": "string",
                    "q3Label": "string",
                },
                "time": {
                    "mean": 0,
                    "min": 0,
                    "q1": 0,
                    "q2": 0,
                    "q3": 0,
                    "max": 0,
                    "minLabel": "string",
                    "maxLabel": "string",
                    "q1Label": "string",
                    "q2Label": "string",
                    "q3Label": "string",
                },
                "writes": {
                    "mean": 0,
                    "min": 0,
                    "q1": 0,
                    "q2": 0,
                    "q3": 0,
                    "max": 0,
                    "minLabel": "string",
                    "maxLabel": "string",
                    "q1Label": "string",
                    "q2Label": "string",
                    "q3Label": "string",
                },
            }
        ],
        "progress": {
            "pending": 0,
            "ignored": 0,
            "loadCpus": 0,
            "loadMemory": 0,
            "processes": [
                {
                    "index": 0,
                    "pending": 0,
                    "ignored": 0,
                    "loadCpus": 0,
                    "succeeded": 0,
                    "running": 0,
                    "retries": 0,
                    "peakRunning": 0,
                    "name": "string",
                    "loadMemory": 0,
                    "stored": 0,
                    "terminated": False,
                    "aborted": 0,
                    "failed": 0,
                    "peakCpus": 0,
                    "peakMemory": 0,
                    "cached": 0,
                    "submitted": 0,
                }
            ],
            "aborted": 0,
            "succeeded": 0,
            "peakMemory": 0,
            "peakCpus": 0,
            "failed": 0,
            "running": 0,
            "retries": 0,
            "peakRunning": 0,
            "cached": 0,
            "submitted": 0,
        },
    }
)
